#!/usr/bin/perl
# Encrypts the username and password for a dyndns account.
# This is part of the opt_dyndns package for fli4l

if ($#ARGV != 1) {
    print "usage: userencode.pl <subdomain> <password>\n";
    return 1;
}

my $subdomain=$ARGV[0];
my $password=$ARGV[1];

print encode("$subdomain:$password"), "\n";
exit 0;

sub encode {
    my $res = "";
    my $in = shift;
    my $eol = (shift || "\n");
    pos($in) = 0;                          # ensure start at the beginning
    while ($in =~ /(.{1,45})/gs) {
        $res .= substr(pack('u', $1), 1);
        chop($res);
    }
    $res =~ tr|` -_|AA-Za-z0-9+/|;               # `# help emacs
    # fix padding at the end
    my $padding = (3 - length($in) % 3) % 3;
    $res =~ s/.{$padding}$/'=' x $padding/e if $padding;
    # break encoded string into lines of no more than 76 characters each
    if (length $eol) {
        $res =~ s/(.{1,76})/$1$eol/g;
    }
        return $res;
}